import syslog

_trace_log_level = False


def open_log(log_ident, log_level):
    """
    :type log_ident: str
    :type log_level: str
    """
    edge_to_syslog_log_level_map = {'trace': syslog.LOG_DEBUG,
                                    'debug': syslog.LOG_DEBUG,
                                    'info': syslog.LOG_INFO,
                                    'warn': syslog.LOG_WARNING,
                                    'error': syslog.LOG_ERR,
                                    'none': syslog.LOG_CRIT}

    syslog.openlog(ident=log_ident, logoption=syslog.LOG_PID, facility=syslog.LOG_DAEMON)
    syslog_log_level = edge_to_syslog_log_level_map[log_level]
    priority_mask = syslog.LOG_UPTO(syslog_log_level)
    syslog.setlogmask(priority_mask)

    global _trace_log_level
    _trace_log_level = (log_level == 'trace')


def close_log():
    syslog.closelog()


def log_trace(entry_text):
    """
    :type entry_text: str
    """
    if _trace_log_level:
        syslog.syslog(syslog.LOG_DEBUG, entry_text)


def log_debug(entry_text):
    """
    :type entry_text: str
    """
    syslog.syslog(syslog.LOG_DEBUG, entry_text)


def log_info(entry_text):
    """
    :type entry_text: str
    """
    syslog.syslog(syslog.LOG_INFO, entry_text)


def log_warning(entry_text):
    """
    :type entry_text: str
    """
    syslog.syslog(syslog.LOG_WARNING, entry_text)


def log_error(entry_text):
    """
    :type entry_text: str
    """
    syslog.syslog(syslog.LOG_ERR, entry_text)
